open Map
open Turing
  
module Ordered_Cells =
struct
  type t = tbigcell * tpos * tstate
  let compare (x,p,s) (x',p',s') =
    if x <> x'
    then x - x'
    else
      if s <> s'
      then s - s'
      else
	match p,p' with
	  | Left,Left -> 0
	  | Right,Right -> 0
	  | Left,_ -> 1
	  | _ -> -1
end

module type TMacro_Table =
sig
  open Macro_strip

  module Table_Mapping : Map.S with type key = Ordered_Cells.t

  type tmacro_trans =
      {macro_write : tbigcell; macro_move : tdep;
       macro_new_state : tstate; macro_count : tcount}
  type tmacro_keys = Table_Mapping.key
  type tmacro_table

end
  
module Macro_Table =
struct
  module Table_Mapping = Map.Make (Ordered_Cells)

  type tmacro_trans =
      {macro_write : tbigcell; macro_move : tdep;
       macro_new_state : tstate; macro_count : tcount}
  type tmacro_keys = Table_Mapping.key
  type tmacro_table = tmacro_trans Table_Mapping.t
end
