open Map
open Turing
  
module Ordered_Cells : OrderedType with type t = tbigcell * tpos * tstate

module type TMacro_Table =
sig
  open Macro_strip

  module Table_Mapping : Map.S with type key = Ordered_Cells.t

  type tmacro_trans =
      {macro_write : tbigcell; macro_move : tdep;
       macro_new_state : tstate; macro_count : tcount}
  type tmacro_keys = Table_Mapping.key
  type tmacro_table
end
  
module Macro_Table : TMacro_Table
