open Big_int
open Turing
open Table
open Table
open Find_bb
open Find_BB

let print_machine t =
  let print_move = function
    | Goleft -> print_string "G"
    | Goright -> print_string "D" 
  in
  let print_state n = print_char (char_of_int (n + 65)) in
  let n = Array.length t in
    print_string "-----------------------------";
    print_newline ();
    for i = 0 to n - 1 do
      print_string "| ";
      print_state i;
      print_string " | ";
      for j = 0 to 1 do
	match t.(j).(i) with
	  | TRANS(tr) ->
	      print_int tr.write;
	      print_string " , ";
	      print_move tr.move;
	      print_string " , ";
	      print_state tr.new_state;
	      if j = 0
	      then print_string " | "
	      else
		begin
		  print_string " |";
		  print_newline ()
		end
	  | HALT ->
	      print_int 1;
	      print_string " , ";
	      print_move Goleft;
	      print_string " , H";
	      if j = 0
	      then print_string " | "
	      else
		begin
		  print_string " |";
		  print_newline ()
		end
	  | UNDEF_TRANS -> print_string "  Undef "
	      (* bizarre *)
      done
    done;
    print_string "-----------------------------";
    print_newline ()

let _ =
  let cellsize = 6
  and tablesize = 3 in
  let champion,ones,steps = Find_BB.loop tablesize cellsize in
    print_string "Le castor actif  ";
    print_int tablesize;
    print_string " tats est :";
    print_newline ();
    print_newline ();
    print_machine champion;
    print_newline ();
    print_newline ();
    print_string "Il imprime ";
    print_string (string_of_big_int ones);
    print_string " uns aprs avoir accompli ";
    print_string (string_of_big_int steps);
    print_string " pas.";
    print_newline ()
