(*************************************)
(* File table.mli : transition table *)
(*************************************)

open Turing

(* Module Table : transition table of the machines *)
module type TTable = sig
  
  type ttrans = {write : tcell; move : tdep; new_state : tstate}
  type ttransition = | TRANS of ttrans | UNDEF_TRANS | HALT
  type ttable = ttransition array array

  val init : tsize -> ttable
  val copy : ttable -> ttable
  val add_trans : ttable -> tcell -> tstate -> ttrans -> unit
  val add_halt : ttable -> tcell -> tstate -> unit
end

module Table : TTable
